<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package architectonic_structure
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function architectonic_structure_body_classes( $classes ) {
  global $architectonic_structure_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( architectonic_structure_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'architectonic_structure_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function architectonic_structure_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'architectonic_structure_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function architectonic_structure_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'architectonic_structure_excerpt_more' );


if( ! function_exists( 'architectonic_structure_footer_credit' ) ):
/**
 * Footer Credits
*/
function architectonic_structure_footer_credit() {
    $architectonic_structure_copyright_text = get_theme_mod('architectonic_structure_footer_copyright_text');

    $architectonic_structure_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($architectonic_structure_copyright_text) {
        $architectonic_structure_text .= wp_kses_post($architectonic_structure_copyright_text); 
    } else {
        $architectonic_structure_text .= esc_html__('&copy; ', 'architectonic-structure') . date_i18n(esc_html__('Y', 'architectonic-structure')); 
        $architectonic_structure_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'architectonic-structure');
    }
        $architectonic_structure_text .= '</span>';
       $architectonic_structure_text .= '<span class="by"> '.ARCHITECTONIC_STRUCTURE_THEME_NAME . ' '. esc_html__( 'By ', 'architectonic-structure' ) . '<a href="' . esc_url( 'https://themeignite.com/' ) .'" rel="nofollow" target="_blank">' . esc_html__( 'Themeignite', 'architectonic-structure' ) . '</a>.';
       /* translators: %s: CMS name with link */
        $architectonic_structure_text .= sprintf( esc_html__( ' Powered By %s', 'architectonic-structure' ), '<a href="'. esc_url( __( 'https://wordpress.org/', 'architectonic-structure' ) ) .'" target="_blank">WordPress</a>.' );
        if ( function_exists( 'the_privacy_policy_link' ) ) {
            $architectonic_structure_text .= get_the_privacy_policy_link();
        }
        $architectonic_structure_text .= '</span></div></div>';
    echo apply_filters('architectonic_structure_footer_text', $architectonic_structure_text);
}
add_action('architectonic_structure_footer', 'architectonic_structure_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'architectonic_structure_woocommerce_activated' ) ) {
  function architectonic_structure_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'architectonic_structure_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function architectonic_structure_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $architectonic_structure_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $architectonic_structure_aria_req = ( $req ? " aria-required='true'" : '' );
    $architectonic_structure_required = ( $req ? " required" : '' );
    $architectonic_structure_author   = ( $req ? __( 'Name*', 'architectonic-structure' ) : __( 'Name', 'architectonic-structure' ) );
    $architectonic_structure_email    = ( $req ? __( 'Email*', 'architectonic-structure' ) : __( 'Email', 'architectonic-structure' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'architectonic-structure' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $architectonic_structure_author ) . '" type="text" value="' . esc_attr( $architectonic_structure_commenter['comment_author'] ) . '" size="30"' . $architectonic_structure_aria_req . $architectonic_structure_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'architectonic-structure' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $architectonic_structure_email ) . '" type="text" value="' . esc_attr(  $architectonic_structure_commenter['comment_author_email'] ) . '" size="30"' . $architectonic_structure_aria_req . $architectonic_structure_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'architectonic-structure' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'architectonic-structure' ) . '" type="text" value="' . esc_attr( $architectonic_structure_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'architectonic_structure_change_comment_form_default_fields' );

if( ! function_exists( 'architectonic_structure_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function architectonic_structure_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'architectonic-structure' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'architectonic-structure' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'architectonic_structure_change_comment_form_defaults' );

if( ! function_exists( 'architectonic_structure_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function architectonic_structure_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'architectonic_structure_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function architectonic_structure_get_fallback_svg( $architectonic_structure_post_thumbnail ) {
    if( ! $architectonic_structure_post_thumbnail ){
        return;
    }
    
    $architectonic_structure_image_size = architectonic_structure_get_image_sizes( $architectonic_structure_post_thumbnail );
     
    if( $architectonic_structure_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $architectonic_structure_image_size['width'] ); ?> <?php echo esc_attr( $architectonic_structure_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $architectonic_structure_image_size['width'] ); ?>" height="<?php echo esc_attr( $architectonic_structure_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function architectonic_structure_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-kanit',
        architectonic_structure_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Kanit:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-lato',
        architectonic_structure_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Lato:ital,wght@0,100;0,300;0,400;0,700;0,900;1,100;1,300;1,400;1,700;1,900&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'architectonic_structure_enqueue_google_fonts' );


if( ! function_exists( 'architectonic_structure_site_branding' ) ) :
/**
 * Site Branding
*/
function architectonic_structure_site_branding(){
    $architectonic_structure_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $architectonic_structure_tagline = get_theme_mod( 'header_tagline', false );
    $architectonic_structure_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($architectonic_structure_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('architectonic_structure_site_title_size', '24')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($architectonic_structure_tagline) :
            $architectonic_structure_description = get_bloginfo('description', 'display');
            if ($architectonic_structure_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $architectonic_structure_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'architectonic_structure_navigation' ) ) :
    /**
     * Site Navigation
    */
    function architectonic_structure_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'architectonic_structure_header' ) ) :
/**
 * Header Start
*/
function architectonic_structure_header(){
    $architectonic_structure_header_image = get_header_image();
    $architectonic_structure_sticky_header = get_theme_mod('architectonic_structure_sticky_header');
    ?>
<div id="page-site-header">
    <header id="masthead" class="site-header header-inner" role="banner">
        <div class="theme-menu head_bg"
            <?php if ( ! empty( $architectonic_structure_header_image ) ) : ?>
                style="background-image:url('<?php echo esc_url( $architectonic_structure_header_image ); ?>');background-repeat:no-repeat;background-size:cover;"
            <?php endif; ?>
            data-sticky="<?php echo esc_attr( $architectonic_structure_sticky_header ?: '' ); ?>">

            <div class="topbar-header-2" data-sticky="<?php echo $architectonic_structure_sticky_header; ?>">
                <?php
                    $architectonic_structure_phone    = get_theme_mod('architectonic_structure_header_phone');;
                    $architectonic_structure_phone_text    = get_theme_mod('architectonic_structure_header_phone_text');
                ?>
                <?php if ( get_theme_mod( 'architectonic_structure_show_hide_toggle', false ) ) : ?>
                    <span class="offcanvas-div d-flex">
                        <button type="button" data-bs-toggle="offcanvas" data-bs-target="#demo">
                            <i class="fas fa-bars-staggered"></i>
                        </button>
                        <div class="offcanvas offcanvas-end" id="demo">
                            <div class="offcanvas-header"> 
                                <button type="button" class="btn-close" data-bs-dismiss="offcanvas"></button>
                            </div>
                            <div id="secondary" class="offcanvas-body">
                                <?php dynamic_sidebar( 'header-sidebar' ); ?>
                            </div>
                        </div>
                    </span>
                <?php endif; ?>   
                <div class="container">
                    <div class="row">
                        <div class="col-xl-2 col-lg-3 col-md-12 col-12 align-self-center acc-order">
                            <?php architectonic_structure_site_branding(); ?>
                        </div>
                        <div class="col-xl-8 col-lg-6 col-md-12 col-12 align-self-center py-2 middle-box d-flex justify-content-between">
                            <div class="middle-header">
                                <?php architectonic_structure_navigation(); ?>
                            </div>
                            <!--Search-->
                            <?php if( get_theme_mod('architectonic_structure_show_hide_search', false) ) { ?>
                                <div class="search-body">
                                    <button type="button" class="search-show">
                                        <i class="<?php echo esc_attr(get_theme_mod('architectonic_structure_search_icon', 'fas fa-search')); ?>"></i>
                                    </button>
                                </div>
                                <div class="searchform-inner">
                                    <?php get_search_form(); ?>
                                    <button 
                                        type="button" 
                                        class="close" 
                                        aria-label="<?php esc_attr_e( 'Close', 'architectonic-structure' ); ?>"
                                    >
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div> 
                            <?php } ?> 
                        </div> 
                        <div class="col-xl-2 col-lg-3 col-md-12 col-12 align-self-center phone-box">
                            
                            <?php if ($architectonic_structure_phone) : ?>
                                <div class="phone-info">
                                    <a href="tel:<?php echo esc_attr($architectonic_structure_phone); ?>" class="d-flex align-items-center">
                                        <span class="contact-icon">
                                            <i class="<?php echo esc_attr(get_theme_mod('architectonic_structure_phone_icon','fas fa-phone-volume')); ?>"></i>
                                        </span>
                                        <span class="contact-box">
                                            <span class="phone-text">
                                                <p><?php echo esc_html($architectonic_structure_phone_text); ?></p>
                                                <h6 class="main-text"><?php echo esc_html($architectonic_structure_phone); ?></h6>
                                            </span>
                                        </span>
                                    </a>
                                </div>
                            <?php endif; ?>

                        </div>
                    </div>
                </div> 
            </div>
        </div>
    </header>
</div>
    <?php
}
endif;
add_action( 'architectonic_structure_header', 'architectonic_structure_header', 20 );
